<?php
/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


require_once('lib/statusgruppe.inc.php');
require_once('DateObject.class.php');

class DBM {

	var $config;

	function DBM($config) {
		$this->config = &$config;
	}

	function has_overlapping_dates($termin_id, $von, $bis, $range_id, $ignore_fulltime=TRUE) {
                $ret = array();
                $date_range = "(date<=$von AND end_time>=$bis) OR (end_time>$von AND end_time<=$bis) OR (date<$bis AND date>=$von) OR (date>=$von AND end_time<=$bis)";
		$addon = ($ignore_fulltime ? " AND fulltime=0" : "");
		if ($this->config->get('only_own_dates'))
			$addon .= sprintf(" AND user_id='%s'",$GLOBALS['auth']->auth['uid']);

                $query = "";
                $query .= sprintf("SELECT termin_id, (end_time - date) delta FROM gk_termine WHERE range_id='%s' AND (%s) %s",$range_id, $date_range, $addon);
                if ($this->config->get('include_sem_dates')) {
                        $query .= " UNION ";
                        $query .= sprintf("SELECT termin_id, (end_time - date) delta FROM termine WHERE range_id='%s' AND (%s)",$range_id, $date_range);
                }
		if ($this->config->isTerminvergabeEnabled() && $this->config->get('include_tv_dates')) {
                        $query .= " UNION ";
			$query .= sprintf(" SELECT t.termin_id, (t.bis - t.von) delta FROM tv_category c, tv_termine t WHERE c.user_id='%s' AND c.visible=1 AND t.category_id=c.category_id AND (%s) ", $GLOBALS['auth']->auth['uid'], preg_replace(array("/date/","/end_time/"),array("von","bis"),$date_range));
		}
		if ($this->config->get('include_calendar_dates')) {
                        $query .= " UNION ";
			$query .= sprintf(" SELECT event_id termin_id, (end - start) delta FROM calendar_events WHERE range_id='%s' AND autor_id='%s' AND (%s) ", $GLOBALS['auth']->auth['uid'], $GLOBALS['auth']->auth['uid'], preg_replace(array("/date/","/end_time/"),array("start","end"),$date_range));
		}

		$query .= " ORDER BY delta";
                $db = new DB_Seminar();
                $db->query($query);
                while ($db->next_record())
                        array_push($ret, $db->f("termin_id"));
                return $ret;
        }

	function getDatesInRange($von, $bis, $range_id, $ignore_fulltime=TRUE, $ordering="delta DESC") {
                $date_range = "(date<=$von AND end_time>=$bis) OR (end_time>$von AND end_time<=$bis) OR (date<$bis AND date>=$von) OR (date>=$von AND end_time<=$bis)";
		$addon = ($ignore_fulltime ? " AND fulltime=0" : "");
                if ($this->config->get('only_own_dates'))
                        $addon .= sprintf(" AND user_id='%s'",$GLOBALS['auth']->auth['uid']);

                $db = new DB_Seminar();
                $query = "";
                $query .= sprintf("SELECT g.termin_id, g.date, g.end_time, g.ort, g.user_id, g.title, g.color, 1 date_type, g.content, g.fulltime, (g.end_time - g.date) delta, g.serie_id serie_id, g.range_id, g.write_perm, g.write_perm_group, g.mkdate, g.chdate, g.ch_user_id, 'group_cal' src FROM gk_termine g WHERE g.range_id='%s' AND (%s) %s ", $range_id, $date_range, $addon);
                if ($this->config->get('include_sem_dates')) {
                        $query .= " UNION ";
                        $query .= sprintf("SELECT /*SQL_CACHE*/ t.termin_id, t.date, t.end_time, t.raum ort, t.autor_id user_id, th.title, 'wei' color, 0 date_type, null content, 0 fulltime, (t.end_time - t.date) delta, null serie_id, t.range_id, null write_perm, null write_perm_group, t.mkdate, t.chdate, null ch_user_id, 'sem_cal' src FROM termine AS t LEFT JOIN themen_termine AS tt USING (termin_id) LEFT JOIN themen AS th USING (issue_id) WHERE t.range_id='%s' AND (%s)", $range_id, $date_range);
                }
		if ($this->config->isTerminvergabeEnabled() && $this->config->get('include_tv_dates')) {
                        $query .= " UNION ";
			$query .= sprintf(" SELECT t.termin_id, t.von date, t.bis end_time, t.ort, t.user_id, c.titel title, 'wei' color, 0 date_type, null content, 0 fulltime, (t.bis - t.von) delta, null serie_id, '%s' range_id, null write_perm, null write_perm_group, 0 mkdate, 0 chdate, null ch_user_id, 'tv_cal' src FROM tv_category c, tv_termine t WHERE c.user_id='%s' AND c.visible=1 AND t.category_id=c.category_id AND (%s) ", $range_id, $GLOBALS['auth']->auth['uid'], preg_replace(array("/date/","/end_time/"),array("von","bis"),$date_range));
		}
		if ($this->config->get('include_calendar_dates')) {
                        $query .= " UNION ";
			$query .= sprintf(" SELECT event_id termin_id, start date, end end_time, location ort, autor_id user_id, summary title, 'wei' color, 0 date_type, description content, 0 fulltime, (end - start) delta, null serie_id, '%s' range_id, null write_perm, null write_perm_group, mkdate, chdate, null ch_user_id, 'pers_cal' src FROM calendar_events WHERE range_id='%s' AND autor_id='%s' AND (%s) ", $range_id, $GLOBALS['auth']->auth['uid'], $GLOBALS['auth']->auth['uid'], preg_replace(array("/date/","/end_time/"),array("start","end"),$date_range));
		}

		$query .= " ORDER BY ".$ordering;
                $db->query($query);
                $ret = array();
                while ($db->next_record()) {
			$d = new DateObject();
			$d->loadFromArray($db->Record);
                        array_push($ret, $d);
		}
                return $ret;
        }

	function getFulltimeDatesInRange($von, $bis, $range_id) {
                $date_range = "(date<=$von AND end_time>=$bis) OR (end_time>$von AND end_time<=$bis) OR (date<$bis AND date>=$von) OR (date>=$von AND end_time<=$bis)";
		$addon = " AND fulltime=1";
                if ($this->config->get('only_own_dates'))
                        $addon .= sprintf(" AND user_id='%s'",$GLOBALS['auth']->auth['uid']);

                $db = new DB_Seminar();
                $query = "";
                $query .= sprintf("SELECT g.termin_id FROM gk_termine g WHERE g.range_id='%s' AND (%s) %s ", $range_id, $date_range, $addon);
                $db->query($query);
                $ret = array();
                while ($db->next_record()) {
			$d = new DateObject();
			$d->load($db->f('termin_id'));
                        array_push($ret, $d);
		}
                return $ret;
        }

	function getSingleDate($termin_id, $range_id) {
		$db = new DB_Seminar();
		$query = "";
                $query .= sprintf("SELECT g.termin_id, g.date, g.end_time, g.ort, g.user_id, g.title, g.color, 1 date_type, g.content, g.fulltime, (g.end_time - g.date) delta, g.range_id, g.serie_id serie_id, g.write_perm, g.write_perm_group, g.mkdate, g.chdate, g.ch_user_id, 'group_cal' src FROM gk_termine g WHERE g.range_id='%s' AND g.termin_id='%s' ", $range_id, $termin_id);
                if ($this->config->get('include_sem_dates')) {
                        $query .= " UNION ";
                        $query .= sprintf("SELECT /*SQL_CACHE*/ t.termin_id, t.date, t.end_time, t.raum ort, t.autor_id user_id, th.title, 'wei' color, 0 date_type, null content, 0 fulltime, (t.end_time - t.date) delta, t.range_id, null serie_id, null write_perm, null write_perm_group, t.mkdate, t.chdate, null ch_user_id, 'sem_cal' src FROM termine AS t LEFT JOIN themen_termine AS tt USING (termin_id) LEFT JOIN themen AS th USING (issue_id) WHERE t.range_id='%s' AND t.termin_id='%s'", $range_id, $termin_id);
                }
		if ($this->config->isTerminvergabeEnabled() && $this->config->get('include_tv_dates')) {
                        $query .= " UNION ";
			$query .= sprintf(" SELECT t.termin_id, t.von date, t.bis end_time, t.ort, t.user_id, c.titel title, 'wei' color, 0 date_type, null content, 0 fulltime, (t.bis - t.von) delta, c.user_id range_id, null serie_id, null write_perm, null write_perm_group, 0 mkdate, 0 chdate, null ch_user_id, 'tv_cal' src FROM tv_category c, tv_termine t WHERE c.user_id='%s' AND c.visible=1 AND t.category_id=c.category_id AND t.termin_id='%s'", $GLOBALS['auth']->auth['uid'], $termin_id);
		}
		if ($this->config->get('include_calendar_dates')) {
                        $query .= " UNION ";
			$query .= sprintf(" SELECT event_id termin_id, start date, end end_time, location ort, autor_id user_id, summary title, 'wei' color, 0 date_type, description content, 0 fulltime, (end - start) delta, range_id, null serie_id, null write_perm, null write_perm_group, mkdate, chdate, null ch_user_id, 'pers_cal' src FROM calendar_events WHERE autor_id='%s' AND range_id='%s' AND event_id='%s'", $GLOBALS['auth']->auth['uid'], $GLOBALS['auth']->auth['uid'], $termin_id);
		}

		$query .= " ORDER BY delta DESC";
                $db->query($query);
                $ret = array();
                if ($db->next_record()) {
			$d = new DateObject();
			$d->loadFromArray($db->Record);
                        array_push($ret, $d);
		}
                return $ret;

	}

	function getSerie($serie_id, $range_id) {
		$db = new DB_Seminar();
		$query = "";
                $query .= sprintf("SELECT termin_id FROM gk_termine WHERE range_id='%s' AND serie_id='%s' ", $range_id, $serie_id);
		$query .= " ORDER BY date DESC";
                $db->query($query);
                $ret = array();
                while ($db->next_record()) {
			$d = new DateObject();
			$d->load($db->f('termin_id'));
                        array_push($ret, $d);
		}
                return $ret;

	}

	function getStatusgruppen($range_id, $user_id) {
		$ret = array();
                $db = new DB_Seminar();
                if ($GLOBALS['perm']->have_studip_perm('tutor', $range_id, $user_id)) {
                        $db->queryf("SELECT statusgruppe_id, name FROM statusgruppen WHERE range_id='%s' ORDER BY 2", $range_id);
                        while ($db->next_record())
                                 $ret[$db->f('statusgruppe_id')] = $db->f('name');
                        return (count($ret) ? $ret : FALSE);
                        //return GetAllStatusgruppen($this->range_id);
                } else {
                        $db->queryf("SELECT su.statusgruppe_id, s.name FROM statusgruppe_user su, statusgruppen s WHERE su.user_id='%s' AND s.statusgruppe_id=su.statusgruppe_id AND s.range_id='%s' ORDER BY 2",$user_id, $range_id);
                        while ($db->next_record())
                                $ret[$db->f('statusgruppe_id')] = $db->f('name');
                        return (count($ret) ? $ret : FALSE);
                        //return GetStatusgruppen($this->range_id, $user_id);
                }
/*
		if ($GLOBALS['perm']->have_studip_perm('tutor', $range_id, $user_id)) {
			return GetAllStatusgruppen($range_id);
		} else {
			return GetStatusgruppen($range_id, $user_id);
		}*/
	}

	function hasEditRights($range_id, $user_id, $t) {
		if ($GLOBALS['perm']->have_studip_perm('dozent', $range_id, $user_id)) {
			return TRUE;
		}
		if ($t->getUserId() == $user_id) {
			return TRUE;
		}
		if ($GLOBALS['perm']->have_studip_perm($t->getWritePerm(), $range_id, $user_id)) {
                	if ($t->getWritePermGroup() != "") {
				if (CheckUserStatusgruppe($t->getWritePermGroup(), $user_id)) {
					return TRUE;
				} else {
					return FALSE;
				}
			}
			return TRUE;
		}
		return FALSE;
	}

	function getSerienInfo($serie_id) {
		if (trim($serie_id) == '') return null;
		$ret = array('anz'=>null,'start'=>null,'ende'=>null);
		$db = new DB_Seminar();
		$query = sprintf("SELECT COUNT(termin_id) anz, MIN(date) start, MAX(end_time) ende FROM gk_termine WHERE serie_id='%s'",$serie_id);
		$db->query($query);
		if ($db->next_record()) {
			$ret['anz'] = $db->f('anz');
			$ret['start'] = $db->f('start');
			$ret['ende'] = $db->f('ende');
			return $ret;
		}
		return null;
	}

	function deleteSerie($termin_id, $from=null) {
		$db = new DB_Seminar();
		$t = new DateObject();
                $t->load($termin_id);
		$db->queryf("DELETE FROM gk_termine WHERE range_id='%s' AND serie_id='%s' ".($from ? " AND date>=$from" : ""), $t->getRangeId(), $t->getSerieId());
	}

	function updateSerie($termin_id, $title, $content, $ort, $color, $write_perm, $write_perm_group, $zeit_von, $zeit_bis, $from=null) {
		// beim Update der Serie wird nur der Zeitanteil und nicht der Tag beruecksichtigt!
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$db->queryf("SELECT t.* FROM gk_termine t, gk_termine tt WHERE tt.termin_id='%s' AND t.serie_id=tt.serie_id", $termin_id);
		while ($db->next_record()) {
			$t = new DateObject();
			$t->loadFromArray($db->Record);
			if ($this->hasEditRights($db->f('range_id'), $GLOBALS['auth']->auth['uid'], $t)) {
				$von = mktime(date("H",$zeit_von),date("i",$zeit_von),0,date("m",$t->getVon()),date("d",$t->getVon()),date("Y",$t->getVon()));
				$bis = mktime(date("H",$zeit_bis),date("i",$zeit_bis),0,date("m",$t->getBis()),date("d",$t->getBis()),date("Y",$t->getBis()));
				$db2->queryf("UPDATE gk_termine SET date=%d, end_time=%d, ort='%s', chdate=UNIX_TIMESTAMP(), ch_user_id='%s', title='%s', content='%s', color='%s', write_perm='%s', write_perm_group='%s' WHERE termin_id='%s' AND range_id='%s'".($from ? " AND date>=$from" : ""), 
					$von, $bis, $ort, $GLOBALS['auth']->auth['uid'], $title, $content, $color, $write_perm, $write_perm_group, $db->f('termin_id'), $db->f('range_id'));
			}
		}
	}

	function getFirstDateOfSerie($serie_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM gk_termine WHERE serie_id='%s' ORDER BY date", $serie_id);
		if ($db->next_record())
			return $db->Record;
		else
			return null;
	}

	function getUserForMessaging($id, $mode) {
		$ret = array();
		if (!$id) return $ret;
		$db = new DB_Seminar();
		$msg_mode = ($mode == "on_create" ? "c.receive_msg='on_update' OR c.receive_msg='on_create'" : "c.receive_msg='on_update'");
		$query = sprintf("SELECT a.user_id, a.username FROM auth_user_md5 a, gk_termine t, gk_config c, seminar_user su WHERE t.termin_id='%s' AND su.Seminar_id=t.range_id AND a.user_id=su.user_id AND c.user_id=a.user_id AND (%s) AND a.user_id!='%s'", $id, $msg_mode, $GLOBALS['auth']->auth['uid']);
		$db->query($query);
		while ($db->next_record()) {
			array_push($ret, $db->Record);
		}
		return $ret;
	}

	function getTerminBuchungen($termin_id) {
		$ret = array('anz_buchungen'=>0, 'bookings'=>array());
		$db = new DB_Seminar();
		$db->queryf("SELECT a.Vorname, a.Nachname, a.username, tu.user_id, tu.zusatz, c.zusatz_text, c.zusatz_active  FROM auth_user_md5 a, tv_termine_user tu, tv_termine t, tv_category c WHERE tu.termin_id='%s' AND a.user_id=tu.user_id AND t.termin_id=tu.termin_id AND c.category_id=t.category_id ORDER BY a.Nachname, a.Vorname, a.username",$termin_id);
		$ret['anz_buchungen'] = $db->num_rows();
		while ($db->next_record()) {
			array_push($ret['bookings'], array('user_id'=>$db->f('user_id'), 'zusatz_active'=>$db->f('zusatz_active'), 'zusatz_text'=>$db->f('zusatz_text'), 'zusatz'=>$db->f('zusatz')));
		}
		return $ret;
	}

}

?>
