<?php

/**
* Plugin zum Verwalten eines Gruppenkalenders
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


page_open(array("sess" => "Seminar_Session", "auth" => "Seminar_Default_Auth", "perm" => "Seminar_Perm", "user" => "Seminar_User"));
//error_reporting( E_ALL );
$GLOBALS['perm']->check('autor');

require_once("classes/GkConfig.class.php");
require_once("classes/DBM.class.php");
require_once("classes/DateController.class.php");
require_once("classes/Export.class.php");

$db=new DB_Seminar;
if (isset($_REQUEST['datum']) && isset($_REQUEST['modus']) && isset($_REQUEST['range_id'])) {

	$export_path = $GLOBALS['TMP_PATH']."/export";

	$datum = escapeshellcmd(basename($_REQUEST['datum']));
	$modus = escapeshellcmd(basename($_REQUEST['modus']));
	$range_id = escapeshellcmd(basename($_REQUEST['range_id']));

	if (!$GLOBALS['perm']->have_studip_perm('autor', $range_id, $GLOBALS['auth']->auth['uid']))
		exit;

	$config = new GkConfig($GLOBALS['auth']->auth['uid'], $range_id);
        $dbm = new DBM(&$config);
        $dc = new DateController(&$dbm, &$config, $range_id);

	$e = new Export(&$dc, &$config, &$dbm, $range_id);

	if ($_REQUEST['listview'] == "1") {
		$buffer = $e->pdfExportList($datum, $modus, (int)$_REQUEST['von'], (int)$_REQUEST['bis']);
	} else {
		if ($modus == "weekly_view")
			$buffer = $e->pdfExportWeek($datum);
		else if ($modus == "daily_view")
			$buffer = $e->pdfExportDay($datum);
		else if ($modus == "monthly_view")
			$buffer = $e->pdfExportMonth($datum);
		else if ($modus == "yearly_view")
			$buffer = $e->pdfExportYear($datum);
	}

	$fo_file = $export_path."/cal_".$modus."_".$GLOBALS['auth']->auth['uid'].".fo";
	$pdf_file = $export_path. "/cal_".$modus."_".$GLOBALS['auth']->auth['uid'].".pdf";
	@unlink($fo_file);
	@unlink($pdf_file);

	$fo = fopen($fo_file,"w");

	fputs($fo, $buffer);
	fclose($fo);

        $str = $GLOBALS['FOP_SH_CALL']." $fo_file $pdf_file";

        if ($JAVA_ENV_CALL){
                $str = ". $JAVA_ENV_CALL && " . $str;
        }

        $err = exec($str);

        if (file_exists($pdf_file) && filesize($pdf_file)) {

		$content_type="application/pdf";
		$content_disposition="inline";

		ob_start();
		header("Expires: Mon, 12 Dec 2001 08:00:00 GMT");
		header("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
		if ($_SERVER['HTTPS'] == "on"){
			header("Pragma: public");
			header("Cache-Control: private");
		} else {
			header("Pragma: no-cache");
			header("Cache-Control: no-store, no-cache, must-revalidate");   // HTTP/1.1
		}
		header("Cache-Control: post-check=0, pre-check=0", false);
		header("Content-Type: $content_type; name=\"calendar.pdf\"");
		header("Content-Description: File Transfer");
		header("Content-Transfer-Encoding: binary");
		header("Accept-Ranges: bytes");
		header("Content-Length: ".filesize($pdf_file));
		header("Content-Disposition: $content_disposition; filename=\"calendar.pdf\"");
		ob_end_flush();

		readfile($pdf_file);;
        } else {
                echo "Fehler beim PDF-Export!<BR>".$err;
                echo "<BR>".$str;
                echo "<BR>FOP:".$fo_file;
                echo "<BR>PDF:".$pdf_file;
        }
}

// Save data back to database.
page_close();
?>
